## Créé le 8/6/2020 ##

######################################################
#  ___         __    __  ___         __   ___  ____  #
#  |__| |  |  /  \  /    |__| |  |  /  \  |__| |     #
#  |    |--| |    | ---- |    |--| |    | |\   |--   #
#  |    |  |  \__/  ___/ |    |  |  \__/  | \  |___  #
#                                                    #
######################################################

##
# Met à jour l'arbre des entités
##
proc maj_arbre_entites {} {
    global tables
    global relations
    global heritages
    global procedures
    set c ".panel.arbre.c"
    set hauteur 20
    set x 20
    # Efface tout ce qui se trouve dans le canvas
    set entites [$c gettags "entite"]
    foreach e $entites {
        $c delete $e
    }
    # Affiche les tables
    $c create text [expr $x + 0] $hauteur -fill black -justify left -text "Tables" -anchor w -tag "entite"
    set hauteur [expr $hauteur + 20]
    set x [expr $x + 20]
    foreach {id table} $tables {
        set nom [dict get $table "nom"]
        $c create text [expr $x + 0] $hauteur -fill black -justify left -text "$id : $nom" -anchor w -tag "entite"
        set hauteur [expr $hauteur + 20]
        #puts "$id : $nom"
    }
    # Saut de ligne
    set hauteur [expr $hauteur + 10]
    # Remet y à sa position initiale
    set x [expr $x - 20]
    # Affiche les relations
    $c create text [expr $x + 0] $hauteur -fill black -justify left -text "Relations" -anchor w -tag "entite"
    set hauteur [expr $hauteur + 20]
    set x [expr $x + 20]
    foreach {id relation} $relations {
        set nom [dict get $relation "nom"]
        $c create rect [expr $x - 5] [expr $hauteur - 9] [expr (($x + (3.1 * [string length $nom])) * 1.5) + 5] [expr $hauteur + 9] -outline #F5F5F5 -fill #F5F5F5 -tag "entite"
        $c create text [expr $x + 0] $hauteur -fill black -justify left -text "$id : $nom" -anchor w -tag "entite"
        set hauteur [expr $hauteur + 20]
        #puts "$id : $nom"
    }
    # Saut de ligne
    set hauteur [expr $hauteur + 10]
    # Remet x à sa position initiale
    set x [expr $x - 20]
    # Affiche les héritages
    #$c create text [expr $x + 0] $hauteur -fill black -justify left -text "Héritages" -anchor w -tag "entite"
    set hauteur [expr $hauteur + 20]
    set x [expr $x + 20]
    foreach {id relation} $heritages {
        set nom [dict get $heritage "nom"]
        #$c create rect [expr $x - 5] [expr $hauteur - 9] [expr (($x + (3.1 * [string length $nom])) * 1.5) + 5] [expr $hauteur + 9] -outline #F5F5F5 -fill #F5F5F5 -tag "entite"
        #$c create text [expr $x + 0] $hauteur -fill black -justify left -text "$id : $nom" -anchor w -tag "entite"
        set hauteur [expr $hauteur + 20]
        #puts "$id : $nom"
    }
    # Saut de ligne
    set hauteur [expr $hauteur + 10]
    # Remet y à sa position initiale
    set x [expr $x - 20]
    # Affiche les procédure stockées
    #$c create text [expr $x + 0] $hauteur -fill black -justify left -text "Procédure stockées" -anchor w -fill blue -tag "entite"
    set hauteur [expr $hauteur + 20]
    set x [expr $x + 20]
    foreach {id relation} $procedures {
        set nom [dict get $procedure "nom"]
        #$c create rect [expr $x - 5] [expr $hauteur - 9] [expr (($x + (3.1 * [string length $nom])) * 1.5) + 5] [expr $hauteur + 9] -outline #F5F5F5 -fill #F5F5F5 -tag "entite"
        #$c create text [expr $x + 0] $hauteur -fill black -justify left -text "$id : $nom" -anchor w -tag "entite"
        set hauteur [expr $hauteur + 20]
        #puts "$id : $nom"
    }
    set x [expr $x - 20]
$c configure -scrollregion [$c bbox all]
}

##
# Met à jour tout l'affichage graphique à partir des variables globales des tables, relations, héritages, ...
# TODO : tout
##
proc maj_canvas {} {

}


##
# Ajout d'un héritage entre plusieurs tables
# TODO : tout
##
proc ajout_heritage {x y} {
    global ID
    lappend graph [.mcd.canvas.c create polygon [list [expr $x - 40] [expr $y + 20] [expr $x + 40] [expr $y + 20] [expr $x - 0] [expr $y - 45]] -outline #FF7000 -fill #FFE3CD -tag [list heritage $ID]]
    set ID [expr $ID + 1]
    unset graph x y
    maj_arbre_entites
}

##
# Déplacement d'une entite
##
proc Katyusha_deplace_entite {type_entite x y tag} {
    global tables_graphique
    global relations_graphique
    global heritages_graphique
    
    set changed_x [expr $x - $atx]
    set changed_y [expr $y - $aty]
    if {$typ_entite == "table"} {
        for {set c 0} {$c < 4} {incr c} {
            .mcd.canvas.c move [lindex [dict get $tables_graphique $tag] $c] $changed_x $changed_y
        }
    }
    set atx $x
    set aty $y
    update
}
