#!/usr/bin/env tclsh
##
# Génération des relations entre les tables
##
proc Katyusha_relations_sql2 {relations sgbd} {
    set SQL ""
    # Liste des tables qui vont être créées ou non en fonction des liens entre les relations et les tables
    # Ces tables vont venir s'ajouter aux tables existantes
    set tables_tmp [list]
    foreach {k relation} $relations {
        set nom_relation [dict get $relation "nom"]
        # Au cas ou il faudrait créer une table spécifique à cette relation
        set attributs [dict create]
        set c 0
        # Balayage des liens
        set liens [dict get $relation "liens"]
        foreach {k lien} $liens {
            set table_lien [lindex $lien 0]
            set n_lien [lindex $lien 1]
            # Types de liens
            # Si au moins un lien de la relation est "0.1" ou "1.1", il n'est pas nécessaire de créer une
            # tables spécifique
            set n_table 1
            if {[dict size $liens] <= 2} {
                if {$n_lien == "0.1" || $n_lien == "1.1"} {
                    set n_table 0
                # Si tous les liens de la relation sont "0.n" ou "1.n", il sera nécessaire de créer une table
                # spécifique car il faudra stocker cette valeur
                } elseif {$n_lien == "0.n" || $n_lien == "1.n" && $n_table == 1} {
                    # Liste des clefs primaires de la table
                    set liste_pk_table [Katyusha_pk_table $table_lien $sgbd]
                    # Balayage des clefs primaires
                    foreach attribut $liste_pk_table {
                        lappend attributs $attribut
                        set c [expr $c + 1]
                    }
                }
            # Si il y a plus de 2 liens, une nouvelle tables est créée obligatoirement
            } else {
                set n_table 1
            }
        }
        # Si il faut créer une nouvelle table pour la relation
        if {$n_table == 1} {
            set table_tmp [dict create]
            dict set table_tmp "nom" $nom_relation
            dict set table_tmp "description" ""
            dict set table_tmp "attributs" $attributs
            lappend tables_tmp $table_tmp
            puts $table_tmp
        # Sinon, ajoute aux tables les clefs étrangères
        # Uniquement pour deux tables ou moins
        } else {
            set table_lier "null"
            foreach {k lien} $liens {
                set table_lien [lindex $lien 0]
                set n_lien [lindex $lien 1]
                if {$n_lien == "0.n" || $n_lien == "1.n"} {
                    set table_lier $table_lien
                }
                if {$table_lier != "null"} {
                    set pk_table_lier [Katyusha_pk_table $table_lier $sgbd]
                    set sql_tmp [Katyusha_ajout_fk_table $table_lien $table_lier $pk_table_lier $sgbd]
                    set SQL "$SQL$sql_tmp"
                }
            }
        }
    }
    return [list $SQL $tables_tmp]
}